package com.izouma.dingdong.web.user;

import com.izouma.dingdong.web.BaseController;
import com.izouma.dingdong.domain.user.Feedback;
import com.izouma.dingdong.service.user.FeedbackService;
import com.izouma.dingdong.dto.PageQuery;
import com.izouma.dingdong.exception.BusinessException;
import com.izouma.dingdong.repo.user.FeedbackRepo;
import com.izouma.dingdong.utils.ObjUtils;
import com.izouma.dingdong.utils.excel.ExcelUtils;

import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/feedback")
@AllArgsConstructor
public class FeedbackController extends BaseController {
    private FeedbackService feedbackService;
    private FeedbackRepo feedbackRepo;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public Feedback save(@RequestBody Feedback record) {
        if (record.getId() != null) {
            Feedback orig = feedbackRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return feedbackRepo.save(orig);
        }
        return feedbackRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @GetMapping("/all")
    public Page<Feedback> all(PageQuery pageQuery) {
        return feedbackRepo.findAll(toSpecification(pageQuery,Feedback.class), toPageRequest(pageQuery));
    }

    @GetMapping("/get/{id}")
    public Feedback get(@PathVariable Long id) {
        return feedbackRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        feedbackRepo.deleteById(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<Feedback> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }
}

